; adc_wizard_apr11.a51  ; ADC test, done with configuration wizard Jan 11: pins reassigned
; ADC as voltmeter (8 bits displayed on LCD), input on P0.0

; rev path 3/16
	$NOSYMBOLS		; keeps listing short
	$INCLUDE (C:\SiLabs\MCU\INC\c8051f410.inc) 
	$INCLUDE (C:\SiLabs\MCU\INC\VECTORS320.INC)	; Tom's vectors definition file

	STACKBOT EQU 080h					; put stack at start of scratch indirectly-addressable block (80h and up)
	DISPLAY_HI EQU P2
	DISPLAY_LO EQU P1


	ORG 0h
	LJMP STARTUP        

	ORG 080h
				
STARTUP: MOV SP, #STACKBOT-1

	acall USUAL_SETUP
	acall SETUP_ANALOG
	acall Init_Device


START_ADC: 	mov ADC0CN, #84h		;  low on AD0BUSY
	mov ADC0CN, #94h		;  high on ADOBUSY starts conversion
	jnb ADC0CN.5, $		; hang here till conversion-done flag
	mov DISPLAY_HI, ADC0H
	mov DISPLAY_LO, ADC0L		; show ADC value on display
	sjmp START_ADC



;------- INITIALIZATIONS

USUAL_SETUP: anl   PCA0MD, #NOT(040h)        ; Disable the WDT.
        ret                                     ; Clear Watchdog Enable bit

SETUP_ANALOG: setb P0.0		; set pin high, to permit use as analog pin (this for ADC)
		ret

; Initialization function for device,
; Call Init_Device from your main program
Init_Device:
    lcall ADC_Init
    lcall Voltage_Reference_Init
    lcall Port_IO_Init
    ret


; Peripheral specific initialization functions,
; Called from the Init_Device label

ADC_Init:
    mov  ADC0MX,    #000h
    mov  ADC0CN,    #084h
    ret

Voltage_Reference_Init:
    mov  REF0CN,    #013h
    ret

Port_IO_Init:
    ; P0.0  -  Skipped,     Open-Drain, Analog
    ; P0.1  -  Unassigned,  Open-Drain, Digital
    ; P0.2  -  Unassigned,  Open-Drain, Digital
    ; P0.3  -  Unassigned,  Open-Drain, Digital
    ; P0.4  -  Unassigned,  Open-Drain, Digital
    ; P0.5  -  Unassigned,  Open-Drain, Digital
    ; P0.6  -  Unassigned,  Open-Drain, Digital
    ; P0.7  -  Unassigned,  Open-Drain, Digital

    ; P1.0  -  Unassigned,  Open-Drain, Digital
    ; P1.1  -  Unassigned,  Open-Drain, Digital
    ; P1.2  -  Skipped,     Open-Drain, Analog
    ; P1.3  -  Unassigned,  Open-Drain, Digital


    mov  P0MDIN,    #0FEh   ; make ADC analog
    mov  P1MDIN,    #0FBh
    mov  P0SKIP,    #0A1h   ; skip ADC and INT0* pins
    mov  P1SKIP,    #004h
    mov  XBR1,      #040h
    ret


end
